﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using ThinkGeo.MapSuite.MapSuiteGeocoder;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Microsoft.Practices.Prism.Commands;

namespace GeocodingDemo
{
    internal class VM : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public ICommand Geocode { get; private set; }

        public VM()
        {
            this.Geocode = new DelegateCommand<object>(a => DoGeocode(), a => true);
            Match1 = new ObservableCollection<string>();
            Match2 = new ObservableCollection<string>();
        }

        private void DoGeocode()
        {
            Match1.Clear();
            Match2.Clear();

            UsaGeocoder geo = new UsaGeocoder(@" ADD GEOCODING FILE LOCATION HERE");
            geo.Open();
            Collection<GeocoderMatch> m1 = geo.Match(Search1);
            foreach (GeocoderMatch match in m1)
            {
                if (match.Name.Equals("IntersectionMatchResult"))
                    Match1.Add(match.NameValuePairs["Street"] + ", " + match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("StreetMatchResult") || match.Name.Equals("CoordinatesMatchResult"))
                    Match1.Add(match.NameValuePairs["HouseNumber"] + " " + (!String.IsNullOrEmpty(match.NameValuePairs["PrefixDirectional"]) && !match.NameValuePairs["PrefixDirectional"].Equals("None") ? match.NameValuePairs["PrefixDirectional"] + " " : "") + match.NameValuePairs["Street"] + (!String.IsNullOrEmpty(match.NameValuePairs["SuffixDirectional"]) && !match.NameValuePairs["SuffixDirectional"].Equals("None") ? " " + match.NameValuePairs["SuffixDirectional"] : "") + ", " + match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("CityMatchResult"))
                    Match1.Add(match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("StateMatchResult"))
                    Match1.Add(match.NameValuePairs["State"]);
                else if (match.Name.Equals("ZipMatchResult"))
                    Match1.Add(match.NameValuePairs["Zip"]);
                else
                    Match1.Add(match.Name);

            }

            Collection<GeocoderMatch> m2 = geo.Match(Search2);
            foreach (GeocoderMatch match in m2)
            {
                if (match.Name.Equals("IntersectionMatchResult"))
                    Match2.Add(match.NameValuePairs["Street"] + ", " + match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("StreetMatchResult") || match.Name.Equals("CoordinatesMatchResult"))
                    Match2.Add(match.NameValuePairs["HouseNumber"] + " " + (!String.IsNullOrEmpty(match.NameValuePairs["PrefixDirectional"]) && !match.NameValuePairs["PrefixDirectional"].Equals("None") ? match.NameValuePairs["PrefixDirectional"] + " " : "") + match.NameValuePairs["Street"] + (!String.IsNullOrEmpty(match.NameValuePairs["SuffixDirectional"]) && !match.NameValuePairs["SuffixDirectional"].Equals("None") ? " " + match.NameValuePairs["SuffixDirectional"] : "") + ", " + match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("CityMatchResult"))
                    Match2.Add(match.NameValuePairs["City"] + " " + match.NameValuePairs["State"]);
                else if (match.Name.Equals("StateMatchResult"))
                    Match2.Add(match.NameValuePairs["State"]);
                else if (match.Name.Equals("ZipMatchResult"))
                    Match2.Add(match.NameValuePairs["Zip"]);
                else
                    Match2.Add(match.Name);

            }
            geo.Close();

            
        }

        private string search1 = "3600 Topanga Canyon Boulevard, Woodland Hills, CA";
        public string Search1
        {
            get { return search1; }
            set
            {
                search1 = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("Search1"));
            }
        }

        private string search2 = "3600 Topanga Canyon Boulevard, Woodland Hills, CA 91364";
        public string Search2
        {
            get { return search2; }
            set
            {
                search2 = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("Search2"));
            }
        }

        private ObservableCollection<string> match1;
        public ObservableCollection<string> Match1
        {
            get { return match1; }
            set
            {
                match1 = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("Match1"));
            }
        }

        private ObservableCollection<string> match2;
        public ObservableCollection<string> Match2
        {
            get { return match2; }
            set
            {
                match2 = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("Match2"));
            }
        }
    }
}
